/* $Header: /usr2/brugere/jbln/uc133/src/RCS/tree.c,v 1.4 1995/02/24 02:13:54 jbln Exp $ */

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>

#include "uc.h"
#include "lists.h"

static int mkt_mycmp1();
static int mkt_mycmp2();

#define MAXLVL 100



test_maketree(pos, do_scan)
int pos;
int do_scan;
{
   if (uc[pos].showmode != SHOWTREE)
      return(0);
   
   if (do_scan)
      maketree(pos, "/");
   else
   {
      if (readtree(pos) == 0)
         maketree(pos, "/");
   }

   return(1);
}


maketree(pos,path)
int pos;
char *path;
{
   NAMELIST *visited = NULL;
   char cnt[MAXLVL];
   char oldpath[UCPATHSIZE];
   int n;

   if (getcwd(oldpath, UCPATHSIZE-1) == NULL)
      return(0);
   if (chdir(path) < 0)
      return(0);

   reset_ucfiles(pos);
   uc[pos].sorting = SORT_NAME;
   memset(cnt, 0, sizeof(char)*MAXLVL);

   move(22,0);
   printw("Reading directory: ");
   rec_maketree(pos, cnt,0,visited);

   if (chdir(oldpath) < 0)
      return(0);

   return(1);
}


rec_maketree(pos, cnt, level, visited)
int pos;
char cnt[MAXLVL];
int level;
NAMELIST *visited;
{
   FILEINFO *fi;
   char curpath[UCPATHSIZE];
   DIR *dirp;
   struct dirent *dp;
   struct stat fstat;
   char **fname, *p;
   int use_this;
   int n,m, num=0;

      /* Test recursion level */
   if (level >= MAXLVL)
      return(0);

      /* Check directory link loops */
   getcwd(curpath, UCPATHSIZE);
   if (lst_exists(visited, curpath))
      return(0);
   visited = lst_add(visited, curpath);

   if (level == 2)
   {
      move(22,19);
      clrtoeol();
      printw("%.55s", curpath);
      refresh();
   }

      /* Read and count avaiable directories */
   dirp = opendir(".");
   if (dirp != (DIR *)NULL)
   {
      while ((dp=readdir(dirp)) != NULL)
      {
         use_this = 1;

	 if (dp->d_name[0] == '.'  &&  dp->d_name[1] == 0)
	    use_this = 0;
	 if (dp->d_name[0] == '.'  &&  dp->d_name[1] == '.')
	    use_this = 0;

         if (strcmp(dp->d_name, "testing") == 0)
            move(0,0);

         if (stat(dp->d_name, &fstat) >= 0)
         {
            if ( (fstat.st_mode & FMODE_SPEC) != FMODE_DIR)
               use_this = 0;
         }
         else
            use_this = 0;

         if (use_this)
         {
            if (num == 0)
            {
               fi = (FILEINFO *)malloc(sizeof(FILEINFO));
               fname = malloc(sizeof(char *));
            }
            else
            {
               fi = (FILEINFO *)realloc(fi, sizeof(FILEINFO)*(num+1));
               fname = realloc(fname, sizeof(char *)*(num+1));   
            }

            fname[num] = strdup(dp->d_name);
            fi[num].name = fname[num];

            fi[num].size = fstat.st_size;
            fi[num].mode = fstat.st_mode;
            fi[num].linknum = fstat.st_nlink;
            fi[num].uid = fstat.st_uid;
            fi[num].gid = fstat.st_gid;
            fi[num].mark = 0;
            fi[num].filetime = fstat.st_mtime;
            fi[num].fdate = *localtime(&fstat.st_mtime);
            
            num++;
         }
      }
      closedir(dirp);
   }

   if (num > 0)
   {
      qsort(fname, num, sizeof(char *), mkt_mycmp1);
      qsort(fi, num, sizeof(FILEINFO), mkt_mycmp2);
   }
   
      /* Insert each directory, and try them recursivly */
   for (m=0 ; m<num ; m++)
   {
         /* Allocate room */
      if (uc[pos].allocnum <= uc[pos].filenum)
      {
         uc[pos].allocnum += FALLOCSIZE;
         if (uc[pos].files == (FILEINFO *)NULL)
 	    uc[pos].files = (FILEINFO *)malloc(sizeof(FILEINFO) * uc[pos].allocnum);
         else
	    uc[pos].files = (FILEINFO *)realloc(uc[pos].files, sizeof(FILEINFO) * uc[pos].allocnum);
      }

         /* Set some defaults */
      if (strcmp(fname[m], "testing") == 0)
         uc[pos].files[uc[pos].filenum] = fi[m];
      else
         uc[pos].files[uc[pos].filenum] = fi[m];

      uc[pos].files[uc[pos].filenum].name = strdup(fname[m]);

      uc[pos].files[uc[pos].filenum].tree.path = 
         malloc(strlen(curpath) + strlen(fname[m]) + 2);
      if (*(strrchr(curpath,'/')+1) != 0)
         sprintf(uc[pos].files[uc[pos].filenum].tree.path,
                 "%s/%s", curpath, fname[m]);
      else
         sprintf(uc[pos].files[uc[pos].filenum].tree.path,
                 "%s%s", curpath, fname[m]);

      uc[pos].files[uc[pos].filenum].tree.level = level;

      uc[pos].files[uc[pos].filenum].tree.descr = 
         malloc(level*3+strlen(fname[m])+10);
      p = uc[pos].files[uc[pos].filenum].tree.descr;
      p[0] = 0;

      for (n=0 ; n<level ; n++)
         if (cnt[n])
            strcat(p, "|  ");
         else   
            strcat(p, "   ");

      if (m < num-1)
         strcat(p, "|- ");
      else
         strcat(p, "+- ");

      strcat(p, fname[m]);

      uc[pos].files[uc[pos].filenum].grpname[0] = 0;
      uc[pos].files[uc[pos].filenum].usrname[0] = 0;
      uc[pos].files[uc[pos].filenum].type = FTYPE_DIR;

      uc[pos].filenum++;

      if (chdir(fname[m]) >= 0)
      {
         if (m < num-1)
            cnt[level] = 1;
         else   
            cnt[level] = 0;
         rec_maketree(pos, cnt, level+1, visited);
         chdir(curpath);
      }


      free(fname[m]);
   } 
   if (num > 0)
   {
      free(fi);
      free(fname);
   }

   visited = lst_del(visited, curpath);

   return(1);
}


readtree(pos)
int pos;
{
   FILE *ifile;
   int n,num,len;
   char *p;

   if (uc[pos].showmode != SHOWTREE)
      return(0);

   reset_ucfiles(pos);

   if ((ifile=fopen(FILETREE,"rb")) == NULL)
   {
      prompt("Could not open filetree: ", FILETREE);
      ti_getch();
      return(0);
   }

   if (fread(&num, sizeof(int), 1, ifile) != 1)
   {
      prompt("Error reading filetree: ", FILETREE);
      fclose(ifile);
      ti_getch();
      return(0);
   }

   if (uc[pos].allocnum < num)
   {
      if (uc[pos].allocnum > 0)
         free(uc[pos].files);
      uc[pos].files = (FILEINFO *)malloc(sizeof(FILEINFO)*num);
      uc[pos].allocnum = num;
   }
   uc[pos].filenum = num;

   for (n=0 ; n<num ; n++)
   {
      fread(&uc[pos].files[n], sizeof(FILEINFO), 1, ifile);

      fread(&len, sizeof(int), 1, ifile);
      p = malloc(len+1);
      fread(p, len, 1, ifile);
      p[len] = 0;
      uc[pos].files[n].tree.descr = p;

      fread(&len, sizeof(int), 1, ifile);
      p = malloc(len+1);
      fread(p, len, 1, ifile);
      p[len] = 0;
      uc[pos].files[n].tree.path = p;

      fread(&len, sizeof(int), 1, ifile);
      p = malloc(len+1);
      fread(p, len, 1, ifile);
      p[len] = 0;
      uc[pos].files[n].name = p;
   }

   fclose(ifile);
   return(1);
}


writetree()
{
   FILE *ofile;
   int n;
   int pos=0;
   int len;

   if (uc[pos].showmode != SHOWTREE)
   {
      pos = 1;
      if (uc[pos].showmode != SHOWTREE)
         return(0);
   }

   if ((ofile=fopen(FILETREE,"wb")) == NULL)
   {
      prompt("Could not open filetree: ", FILETREE);
      ti_getch();
      return(0);
   }

   fwrite(&(uc[pos].filenum), sizeof(int), 1, ofile);

   for (n=0 ; n<uc[pos].filenum ; n++)
   {
      fwrite(&uc[pos].files[n], sizeof(FILEINFO), 1, ofile);

      len = strlen(uc[pos].files[n].tree.descr);
      fwrite(&len, sizeof(int), 1, ofile);
      fwrite(uc[pos].files[n].tree.descr, len, 1, ofile);

      len = strlen(uc[pos].files[n].tree.path);
      fwrite(&len, sizeof(int), 1, ofile);
      fwrite(uc[pos].files[n].tree.path, len, 1, ofile);

      len = strlen(uc[pos].files[n].name);
      fwrite(&len, sizeof(int), 1, ofile);
      fwrite(uc[pos].files[n].name, len, 1, ofile);
   }

   fclose(ofile);
   return(1);
}


mkt_show_one(y,pos,info,do_rev)
int y,pos;
FILEINFO *info;
int do_rev;
{
   move(y,pos*40+2);
   printw("%-34.34s", info->tree.descr);

   if (do_rev)
      attrset(A_REVERSE);

   move(y, pos*40 + 2 + info->tree.level*3 + 3);
   printw("%s", info->name);

   if (do_rev)
      attroff(A_REVERSE);
}


mkt_findpos(pos)
int pos;
{
   int n;

   if (uc[pos].showmode != SHOWTREE)
      return(0);

   uc[pos].pos = 0;
   uc[pos].offset = 0;
   uc[pos].oldpos = -1;
   uc[pos].oldoffset = -1;

   for (n=0 ; n<uc[pos].filenum ; n++)
   {
      if (strcmp(uc[pos].files[n].tree.path, uc[pos].path) == 0)
      {
         uc[pos].pos = 0;
         uc[pos].offset = n;
      }
   }

   return(1);
}


mkt_update()
{
   int pos;

   for (pos=0 ; pos<2 ; pos++)
   {
      if (uc[pos].showmode == SHOWTREE)
      {
         test_maketree(pos, 0);
         update_screen(pos);
      }
   }
}


static mkt_mycmp1(a,b)
void *a, *b;
{
   return(strcmp(*(char **)a, *(char **)b));
}


static mkt_mycmp2(a,b)
void *a, *b;
{
   return(strcmp(((FILEINFO *)a)->name, ((FILEINFO *)b)->name));
}

